Subject: bug#12463: 24.2; pos-visible-in-window-p gets slower over time

From: Eli Zaretskii <[email-masked]>
Date: Tue, 18 Sep 2012 19:24:10 +0300

> From: Matt Lundin <[email-masked]>
> Date: Tue, 18 Sep 2012 10:05:34 -0500
> Cc: [email-masked]
> 
> AFAICT, the bottleneck seems to be in the emacs xft rendering. I tested
> this by opening two frames showing the same outline buffer. One of the
> frames was a X frame using xft fonts; another frame was running in a
> console (urxvt, which also uses xft rendering but shows no similar
> slowdown). When opening an outline entry containing multibyte
> characters, it appeared instantly in the console frame but only after a
> substantial lag on the X frame.
> 
> In other words, the culprit may be something other than
> pos-visible-in-window-p.

pos-visible-in-window-p invokes many functions involved in redisplay,
including the font shaper, it just arranges things so that nothing is
output to the glass.  So anything that slows down font shaping will
also slow down pos-visible-in-window-p.

However, in this case it looks like image drawing is the culprit, not
font shaping.